//+---------------------------------------------------------------------------------+
//+ Forex Bullseye                                                                      +
//+     2-                                   +
//+                                                                                 +
//+  :                                                              +
//+  ExtPeriodFastMA -                                           +
//+  ExtPeriodMiddleMA -                                        +
//+  ExtModeFastMA   -                                            +
//+  ExtModeMiddleMA   -                                         +
//+   : 0 = SMA, 1 = EMA, 2 = SMMA (), 3 = LWMA ()        +
//+  ExtPriceFastMA  -                                             +
//+  ExtPriceMiddleMA  -                                          +
//+   : 0 = Close, 1 = Open, 2 = High, 3 = Low, 4 = HL/2, 5 = HLC/3, 6 = HLCC/4 +
//+---------------------------------------------------------------------------------+
#property copyright "Copyright  2013"
#property link      ""

//----  
#property indicator_chart_window
#property indicator_buffers 5
//---- 
#property indicator_color1 Orange // 5
#property indicator_color2 Red       // 13
#property indicator_color3 SpringGreen       //  7
#property indicator_color4 DeepSkyBlue
#property indicator_color5 Red

//---- 
extern int    ExtPeriodFastMA = 5;
extern int    ExtPeriodMiddleMA = 13;
extern int    ExtPeriodSlowMA=7;
extern int    ExtModeFastMA = 1; // 0 = SMA, 1 = EMA, 2 = SMMA, 3 = LWMA
extern int    ExtModeMiddleMA   = 1; // 0 = SMA, 1 = EMA, 2 = SMMA, 3 = LWMA
extern int    ExtModeSlowMA   = 1; // 0 = SMA, 1 = EMA, 2 = SMMA, 3 = LWMA
extern int    ExtPriceFastMA  = 0; // 0 = Close, 1 = Open, 2 = High, 3 = Low, 4 = HL/2, 5 = HLC/3, 6 = HLCC/4
extern int    ExtPriceMiddleMA  = 5; // 0 = Close, 1 = Open, 2 = High, 3 = Low, 4 = HL/2, 5 = HLC/3, 6 = HLCC/4
extern int    ExtPriceSlowMA  = 1; // 0 = Close, 1 = Open, 2 = High, 3 = Low, 4 = HL/2, 5 = HLC/3,
extern string ExtSoundFileName = "alert.wav";


//---- 
double FastMA[];
double MiddleMA[];
double SlowMA[];
double CrossUp[];
double CrossDown[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
  //----   
  //     
  SetIndexStyle( 0, DRAW_LINE );
  SetIndexStyle( 1, DRAW_LINE );
  SetIndexStyle(2,DRAW_LINE);
  //     
  SetIndexStyle( 3, DRAW_ARROW, EMPTY,2 );
  SetIndexArrow( 3, 233 );
  SetIndexStyle( 4, DRAW_ARROW, EMPTY,2 );
  SetIndexArrow( 4, 234 );
  
  //----  
  SetIndexBuffer( 0, FastMA    );
  SetIndexBuffer( 1, MiddleMA    );
  SetIndexBuffer (2,SlowMA );
  SetIndexBuffer( 3, CrossUp   );
  SetIndexBuffer( 4, CrossDown );
  
  IndicatorDigits( MarketInfo( Symbol(), MODE_DIGITS ) );
  
  //----   
  IndicatorShortName( "Forex Bullseye(" + ExtPeriodFastMA + "," + ExtPeriodMiddleMA );
  SetIndexLabel( 0, "MA" + ExtPeriodFastMA );
  SetIndexLabel( 1, "MA" + ExtPeriodMiddleMA );
  SetIndexLabel( 2, "Buy"  );
  SetIndexLabel( 3, "Sell" );
  
  return ( 0 );
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
  static bool bBuy  = False;
  static bool bSell = False;
  
  bool   bConditionUp;
  bool   bConditionDown;
  double Range;
  double AvgRange;
  int    iLimit;
  int    i;
  int    counter;
  int    counted_bars = IndicatorCounted();
  
  //---- check for possible errors
  if ( counted_bars < 0 ) 
    return ( -1 );
  
  //---- last counted bar will be recounted
  if ( counted_bars > 0 ) counted_bars--;
  
  iLimit = Bars - counted_bars;
  
  for ( i = 1; i <= iLimit; i++ ) {
    FastMA[i] = iMA( NULL, 0, ExtPeriodFastMA, 0, ExtModeFastMA, ExtPriceFastMA, i );
    MiddleMA[i] = iMA( NULL, 0, ExtPeriodMiddleMA, 0, ExtModeMiddleMA, ExtPriceSlowMA, i );
    SlowMA[i]=iMA( NULL, 0, ExtPeriodSlowMA, 0, ExtModeSlowMA, ExtPriceSlowMA, i );
  } // for
  
  for ( i = 1; i <= iLimit; i++ ) {
    AvgRange = 0;
    for ( counter = i; counter <= i + 9; counter++ ) {
      AvgRange += MathAbs( High[ counter ] - Low[ counter ] );
    }
    Range = AvgRange/10;
    
    /*if ( i == 0 ) {
      bConditionUp   = ( FastMA[i  ] > MiddleMA[i  ] ) &&
                       ( FastMA[i+1] < MiddleMA[i+1] ); //   
      bConditionDown = ( FastMA[i  ] < MiddleMA[i  ] ) &&
                       ( FastMA[i+1] > MiddleMA[i+1] ); //  
    }
    else {*/
      bConditionUp   = ( FastMA[i  ] > MiddleMA[i  ] ) &&
                       ( FastMA[i+1] < MiddleMA[i+1] ) &&
                       ( FastMA[i+2] < MiddleMA[i+2] ) && 
                       ( FastMA[i+3] < MiddleMA[i+3] )&&//  
                       (NormalizeDouble(FastMA[i]-FastMA[i+3],4)>=0.0002);
      bConditionDown = ( FastMA[i  ] < MiddleMA[i  ] ) &&
                       ( FastMA[i+1] > MiddleMA[i+1] ) &&
                       ( FastMA[i+2] > MiddleMA[i+2] )&& //  
                       ( FastMA[i+3] > MiddleMA[i+3] )&&
                       ( NormalizeDouble(FastMA[i+3]- FastMA[i],4)>=0.0002);
    
    if ( !bBuy && bConditionUp ) {
      // 
      bBuy  = True;  //   
      bSell = False; //   
      
      // 
      CrossUp[i] = Low[i] - Range * 0.5;
      if ( i ==1 ) {
         Comment (Symbol()," ",Period(),"M  Achtung BUY "); //  
         Print (Symbol()," ",Period(),"M  Achtung BUY ");  //  
       //mod if ( ExtSoundFileName != "alert.wav" )
          PlaySound( ExtSoundFileName );
      } // if ( i < 2 )
      
    }
    else if ( !bSell && bConditionDown ) {
      // 
      bSell = True;  //   
      bBuy  = False; //   
      
      // 
      CrossDown[i] = High[i] + Range * 0.5;
      if ( i ==1 ) {
        Comment (Symbol()," ",Period(),"M   Achtung SELL "); //  
        Print (Symbol()," ",Period(),"M  Achtung BUY "); //  
        //mod if ( ExtSoundFileName != "alert.wav" )
          PlaySound( ExtSoundFileName );
      } // if ( i < 2 )
      
    } // if
    
  } // for
   
  return ( 0 );
}